#define in1 6
#define in2 9
#define in3 10
#define in4 11

#define trigFront 5
#define trigRear 3

#define echoFront A4
#define echoRear A5

long front_time;
long rear_time;

int front_distance;
int rear_distance;

String data;

int left_speed;
int right_speed;
int normal_speed;
int turn;

void setup() {
  Serial.begin(9600);

  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);

  pinMode(trigFront, OUTPUT);
  pinMode(trigRear, OUTPUT);

  pinMode(echoFront, INPUT);
  pinMode(echoRear, INPUT);

  rear_distance = 50;
  front_distance = 50;
}

void loop() {
  data = Serial.readStringUntil('\n');

  if (data.length() > 1) {
    if (data.charAt(0) == 'S') {
      normal_speed = data.substring(1).toInt();
    } else if (data.charAt(0) == 'W') {
      turn = data.substring(1).toInt();
    }
  }

  if (normal_speed > 0) {
    if (front_distance < 20) {
      normal_speed = 0;
    } else if (front_distance < 40 && normal_speed > 5) {
      normal_speed = 5;
    }
    if (turn > 0) {
      right_speed = abs(normal_speed - abs((turn * normal_speed)) / 10);
      left_speed = abs(normal_speed);
    } else {
      left_speed = abs(normal_speed - abs((turn * normal_speed)) / 10);
      right_speed = abs(normal_speed);
    }
    analogWrite(in2, 55 + left_speed * 20);
    analogWrite(in3, 55 + right_speed * 20);

    analogWrite(in1, 0);
    analogWrite(in4, 0);
  } else if (normal_speed < 0) {
    if (rear_distance < 20) {
      normal_speed = 0;
    } else if (rear_distance < 40 && normal_speed < -5) {
      normal_speed = -5;
    }
    if (turn > 0) {
      right_speed = abs(normal_speed - abs((turn * normal_speed)) / 10);
      left_speed = abs(normal_speed);
    } else {
      left_speed = abs(normal_speed - abs((turn * normal_speed)) / 10);
      right_speed = abs(normal_speed);
    }
    analogWrite(in1, 55 + left_speed * 20);
    analogWrite(in4, 55 + right_speed * 20);

    analogWrite(in2, 0);
    analogWrite(in3, 0);

  } else {
    analogWrite(in1, 0);
    analogWrite(in2, 0);
    analogWrite(in3, 0);
    analogWrite(in4, 0);
  }

  digitalWrite(trigFront, LOW);
  digitalWrite(trigRear, LOW);
  delayMicroseconds(2);

  digitalWrite(trigFront, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigFront, LOW);

  front_time = pulseIn(echoFront, HIGH);
  front_distance = front_time * 0.034 / 2;

  digitalWrite(trigRear, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigRear, LOW);

  rear_time = pulseIn(echoRear, HIGH);
  rear_distance = rear_time * 0.034 / 2;
}
